;**************************************************************
;***    EMS4F2.ASM                                          ***
;***                                                        ***
;***    function        EMS_Ems.getPMapInfoSize40(          ***
;***                        pages: Word;                    ***
;***                        var buffSize:   Word)           ***
;***                        : Boolean;                      ***
;***                                                        ***
;***    Pointer gets size of partial page map buffer in     ***
;***    bytes.                                              ***
;***                                                        ***
;***    Returns 0 if no error or an error code.             ***
;***                                                        ***
;***                                                        ***
;***    (Ems Version 4.0)                                   ***
;**************************************************************

        .model  large,pascal   

        include emsdefs.asm 

        extrn   errno:WORD  

;
;   Define entry point
;
        public  EMS_Ems@getPMapInfoSize40

        .code

EMS_Ems@getPMapInfoSize40 proc pages:Word, buffSize:Far Ptr Word, self:DWord

        mov     bx,pages                ; BX gets number of pages

        mov     ax,GetPMapInfoSize40    ; Make the EMS call
        int     Ems           

        or      ah,ah                   ; Set flags
        jnz     error

        xor     ah,ah                   ; Zero extend size in AL
        les     bx,buffSize             ; Return it
        mov     es:[bx],ax

        xor     ax,ax                   ; Return OK
        ret         

error:
        mov     al,ah                   ; AL gets error code
        xor     ah,ah                   ; Zero extend
        mov     errno,ax                ; Save in errno too
        ret

EMS_Ems@getPMapInfoSize40 endp          ; End of procedure

        end                             ; End of source file
